<id>
Anguz:FasterParsecode
</id>

<version>
1.00
</version>

<edit file>
$sourcedir/Subs.php
</edit file>

<search for>
// Parses the code in message, using the normal syntax used by some many forums...
function parsecode(&$message)
{
	global $modSettings, $scripturl, $txt, $settings, $context;
	static $codefromcache = array(), $codetocache = array();

	// If it wasn't already set, set it.
	if (empty($codefromcache))
	{
		// If any tags are disabled then we won't add them.
		if (!empty($modSettings['disabledBBC']))
		{
			$disabled = array_flip(explode(',', $modSettings['disabledBBC']));

			foreach ($disabled as $tag => $dummy)
				$disabled[trim($tag)] = true;
		}

		$code_to_from = array(
			// A named email address. [email=me@some.place.com]me[/email]
			'~\[email=(.+?)\](.+?)\[/email\]~ie' => isset($disabled['email']) ? '$2 ($1)' : '\'<a href="mailto:$1">\' . preg_replace(\'~(\[url.*?\]|\[/url\]|\[ftp.*?\]|\[/ftp\])~\', \'\', strtr(\'$2\', array(\'@\' => \'&#64;\'))) . \'</a>\'',
			// Find an inside link. (named?) ie. [iurl]www.simplemachines.org[/iurl]
			'~\[iurl=([^\]]+?)\]([^\[\]]+?)\[/iurl\]~i' => isset($disabled['iurl']) ? (!isset($disabled['url']) ? '<a href="$1" target="_blank">$2</a>' : '$2 ($1)') : '<a href="$1">$2</a>',
			'~\[iurl=(.+?)\](.+?)\[/iurl\]~ie' => isset($disabled['iurl']) ? (!isset($disabled['url']) ? '\'<a href="$1" target="_blank">\' . preg_replace(\'~(\[url.*?\]|\[/url\])~\', \'\', strtr(\'$2\', array(\'@\' => \'&#64;\'))) . \'</a>\'' : 'preg_replace(\'~(\[url.*?\]|\[/url\])~\', \'\', \'$2\') . \' ($1)\'') : '\'<a href="$1">\' . preg_replace(\'~(\[url.*?\]|\[/url\])~\', \'\', strtr(\'$2\', array(\'@\' => \'&#64;\'))) . \'</a>\'',
			'~\[iurl\](.+?)\[/iurl\]~i' => isset($disabled['iurl']) ? (!isset($disabled['url']) ? '<a href="$1" target="_blank">$1</a>' : '$1') : '<a href="$1">$1</a>',
			// FTP link.  Named...?  [ftp=upload.sourceforge.net]Sourceforge[/ftp]
			'~\[ftp\](.+?)\[/ftp\]~ie' => isset($disabled['ftp']) ? 'preg_replace(\'~(\[url.*?\]|\[/url\])~\', \'\', \'$1\')' : '\'<a href="$1" target="_blank">\' . preg_replace(\'~(\[url.*?\]|\[/url\])~\', \'\', strtr(\'$1\', array(\'@\' => \'&#64;\'))) . \'</a>\'',
			'~\[ftp=(.+?)\](.+?)\[/ftp\]~ie' => isset($disabled['ftp']) ? 'preg_replace(\'~(\[url.*?\]|\[/url\])~\', \'\', \'$2\') . \' ($1)\'' : '\'<a href="$1" target="_blank">\' . preg_replace(\'~(\[url.*?\]|\[/url\])~\', \'\', strtr(\'$2\', array(\'@\' => \'&#64;\'))) . \'</a>\'',
			// Find a (named?) URL... [url]www.simplemachines.org[/url] or [url=www.simplemachines.org]SMF[/url]
			'~\[url=([^\]]+?)\]([^\]]*?\[url(?:=[^\]]+?)?\].+?\[/url\].*?)\[/url\]~ie' => isset($disabled['url']) ? 'preg_replace(\'~(\[url.*?\]|\[/url\])~\', \'\', \'$2\') . \' ($1)\'' : '\'<a href="$1" target="_blank">\' . preg_replace(\'~(\[url.*?\]|\[/url\])~\', \'\', strtr(\'$2\', array(\'@\' => \'&#64;\'))) . \'</a>\'',
			'~\[url=(.+?)\](.+?)\[/url\]~ie' => isset($disabled['url']) ? '\'$2 ($1)\'' : '\'<a href="$1" target="_blank">\' . strtr(\'$2\', array(\'@\' => \'&#64;\')) . \'</a>\'',
			'~\[url\](?:<br />)*(.+?)(?:<br />)*\[/url\]~i' => isset($disabled['url']) ? '$1' : '<a href="$1" target="_blank">$1</a>',
			// Bold, italics, underline, strikeout.
			'~\[b\](.+?)\[/b\]~i' => isset($disabled['b']) ? '$1' : '<b>$1</b>',
			'~\[i\](.+?)\[/i\]~i' => isset($disabled['i']) ? '$1' : '<i>$1</i>',
			'~\[u\](.+?)\[/u\]~i' => isset($disabled['u']) ? '$1' : '<span style="text-decoration: underline;">$1</span>',
			'~\[s\](.+?)\[/s\]~i' => isset($disabled['s']) ? '$1' : '<del>$1</del>',
			// A quote.  May or may not specify an author and/or link and date.
			'~\[quote(?: author)?=&quot;(.{1,80}?)&quot;\](?:<br />)?~i' => isset($disabled['quote']) ? '<div>' : '<div class="quoteheader">' . $txt['smf239'] . ': $1</div><div class="quote">',
			'~\[quote author=(.{1,80}?) link=(?:board=\d+;)?((?:topic|threadid)=[\dmsg#\./]{1,40}(?:;start=[\dmsg#\./]{1,40})?) date=(\d+)\](?:<br />)?~ei' => isset($disabled['quote']) ? '\'<div>\'' : '\'<div class="quoteheader"><a href="' . $scripturl . '?$2">' . $txt['smf239'] . ': $1 ' . $txt[176] . ' \' . timeformat(\'$3\') . \'</a></div><div class="quote">\'',
			'~\[quote author=(.{1,80}?)\](?:<br />)?~i' => isset($disabled['quote']) ? '<div>' : '<div class="quoteheader">' . $txt['smf239'] . ': $1</div><div class="quote">',
			'~\[quote\](?:<br />)?~i' => isset($disabled['quote']) ? '<div>' : '<div class="quoteheader">' . $txt['smf240'] . '</div><div class="quote">',
			'~\[/quote\](?:<br />)?~i' => isset($disabled['quote']) ? '</div>' : '</div>',
			// An image.  Width and height can be are optional.
			'~\[img(\s+width=([\d]+))?(\s+height=([\d]+))?\s*\](?:<br />)*(.+?)(?:<br />)*\[/img\]~ei' => isset($disabled['img']) ? '\'$5\'' : '\'<img src="$5" alt=""\' . (\'$2\' != \'\' ? \' width="$2"\' : \'\') . (\'$4\' != \'\' ? \' height="$4"\' : \'\') . \' border="0" />\'',
			// Size the font.  [size=large]HELLO![/size]
			'~\[size=([\d]{1,2}p[xt]|(?:x-)?small(?:er)?|(?:x-)?large[r]?)\](.+?)\[/size\]~i' => isset($disabled['size']) ? '$2' : '<span style="font-size: $1;">$2</span>',
			'~\[size=([\d])\](.+?)\[/size\]~i' => isset($disabled['size']) ? '$2' : '<font size="$1">$2</font>',
			// Performat/justify text.  [center]Justifying is good.[/center]
			'~\[pre\](.+?)\[/pre\]~i' => isset($disabled['pre']) ? '$1' : '<pre>$1</pre>',
			'~\[left\](.+?)\[/left\]~i' => isset($disabled['left']) ? '$1' : '<div align="left">$1</div>',
			'~\[right\](.+?)\[/right\]~i' => isset($disabled['right']) ? '$1' : '<div align="right">$1</div>',
			'~\[center\](.+?)\[/center\]~i' => isset($disabled['center']) ? '$1' : '<div align="center">$1</div>',
			// Teletyped text.  Monospace, in other words.
			'~\[tt\](.+?)\[/tt\]~i' => isset($disabled['tt']) ? '$1' : '<tt>$1</tt>',
			// Subscript and superscript.  6[sup]2[/sup] = 36.
			'~\[sub\](.+?)\[/sub\]~i' => isset($disabled['sub']) ? '$1' : '<sub>$1</sub>',
			'~\[sup\](.+?)\[/sup\]~i' => isset($disabled['sup']) ? '$1' : '<sup>$1</sup>',
			// An email address. [email]me@some.place.com[/email]
			'~\[email\](?:<br />)*(.+?)(?:<br />)*\[/email\]~i' => isset($disabled['email']) ? '$1' : '<a href="mailto:$1">$1</a>',
			// Specify a specific font.  [font=Comic Sans]Blah![/font]
			'~\[font=([\w,\-\s]+?)\](.+?)\[/font\]~i' => isset($disabled['font']) ? '$2' : '<span style="font-family: $1;">$2</span>',
			// Colors.... [red]See?[/red]
			'~\[color=(#[\da-fA-F]{3}|#[\da-fA-F]{6}|[\w]{1,12})\](.*?)\[/color\]~i' => isset($disabled['color']) ? '$2' : '<span style="color: $1;">$2</span>',
			'~\[(black|white|red|green|blue)\](.+?)\[/\1\]~i' => isset($disabled['color']) ? '$2' : '<span style="color: $1;">$2</span>',
			'~\[(chr|k)issy\](.+?)\[/\1issy\]~i' => isset($disabled['color']) ? '$2' : '<span style="color: #CC0099;">$2 :-*</span>',
			// Lists... [list][*]First, ...[o]Second![li]THIRD!!![/li][/list]
			'~\[list\](?:<br />)?~i' => isset($disabled['list']) || isset($disabled['li']) ? '' : '<ul style="margin-top: 0; margin-bottom: 0;">',
			'~\[/list\](?:<br />)?~i' => isset($disabled['list']) || isset($disabled['li']) ? '' : '</ul>',
			'~(?:<br />|&nbsp;|\s)*\[li\](.+?)\[/li\](?:<br />|&nbsp;|\s)*~i' => isset($disabled['list']) || isset($disabled['li']) ? '<br />$1<br />' : '<li>$1</li>',
			// Horizontal rule. [hr] => ------------------
			'~\[hr(?:\s*/)?\]~i' => isset($disabled['hr']) ? '' : '<hr />',
			// A break.  [br] or [br /]. (it makes no sense to disable this one :P.)
			'~\[br(?:\s*/)?\]~i' => '<br />',
			// Right-to-left and left-to-right strings.
			'~\[(ltr|rtl)\](.+?)\[/\1\]~i' => isset($disabled['ltr']) || isset($disabled['rtl']) ? '$2' : '<div dir="$1">$2</div>',
			// Acronyms and abbreviations... [acronym=Bulletin Board Code]BBC[/acronym]
			'~\[abbr=((?:&quot;)?)(.+?)\\1\](.+?)\[/abbr\]~i' => isset($disabled['abbr']) ? '$3 ($2)' : '<abbr title="$2">$3</abbr>',
			'~\[acronym=((?:&quot;)?)(.+?)\\1\](.+?)\[/acronym\]~i' => isset($disabled['acronym']) ? '$3 ($2)' : '<acronym title="$2">$3</acronym>',
			// [me=Comment]does something[/me]
			'~\[me=((?:&quot;)?)(.{1,80}?)\\1\](.+?)\[/me\](?:<br />)?~i' => isset($disabled['ftp']) ? '/me $3<br />' : '<div class="meaction">* $2 $3</div>',
			// An email address they just typed in.  Don't match if there's already a mailto: or = before it.
			'~(?<=[\?\s\xA0[\]()*\\\;>]|^)([\w\-\.]{1,80}@[\w\-]+\.[\w\-\.]+[\w\-])(?=[?,\s\xA0\[\]()*\\\]|$|<br />|&nbsp;|&gt;|&lt;|&quot;|&#039;|\.(?:\.|&nbsp;|\s|$|<br />))~i' => '<a href="mailto:$1">$1</a>',
			'~(?<=<br />)([\w\-\.]{1,80}@[\w\-]+\.[\w\-\.]+[\w\-])(?=[?\.,\s\xA0\[\]()*\\\]|$|<br />|&nbsp;|&gt;|&lt;|&quot;|&#039;)~i' => '<a href="mailto:$1">$1</a>',
			// This last one fixes spaces at the beginning of lines.
			'~<br /> ~' => '<br />&nbsp;',
			// Match a table... hopefully with everything in the right place.
			'~\[table\](?:\s|\xA0|<br />|&nbsp;)*((?:\[tr\](?:\s|\xA0|<br />|&nbsp;)*\[td\]).*?(?:(?:\s|\xA0|<br />|&nbsp;)*\[/td\]\[/tr\])*)(?:\s|\xA0|<br />|&nbsp;)*\[/table\](?:\s|\xA0|<br />|&nbsp;)?~i' => '<table>$1</table>',
		);

		$codefromcache = array_keys($code_to_from);
		$codetocache = array_values($code_to_from);

		// GLOWING or /shadowed/ text.
		$codefromcache[] = '~\[glow=([#\w]{3,12}),([012]\d{0,2})(,[^]]+)?\](.+?)\[/glow\]~i';
		$codetocache[] = isset($disabled['glow']) ? '$4' : '<table border="0" cellpadding="0" cellspacing="0" style="display: inline; vertical-align: middle; font: inherit;"><tr><td style="filter: Glow(color=$1, strength=$2); font: inherit;">$4</td></tr></table> ';
		$codefromcache[] = '~\[shadow=([#\w]{3,12}),(left|right|top|bottom|[0123]\d{0,2})\](.+?)\[/shadow\]~ei';
		$codetocache[] = isset($disabled['shadow']) ? 'strtr(\'$3\', array(\'\\"\' => \'"\')' : '\'<table border="0" cellpadding="0" cellspacing="0" style="display: inline; vertical-align: middle; font: inherit;"><tr><td style="filter: Shadow(color=$1, direction=\' . (isset($shadow_directions[\'$2\']) ? $shadow_directions[\'$2\'] : (int) \'$2\') . \'); font: inherit;">\' . strtr(\'$3\', array(\'\\"\' => \'"\')) . \'</td></tr></table> \'';

		// Moving text... [move]stuff[/move]
		$codefromcache[] = '~\[move\](.+?)\[/move\]~i';
		$codetocache[] = isset($disabled['move']) ? '$1' : '<marquee>$1</marquee>';

		// Handle flash.
		$codefromcache[] = '~\[flash=(\d+),(\d+)\](?:<br />)*(.+?)(?:<br />)*\[/flash\]~i';
		if (empty($modSettings['enableEmbeddedFlash']) || $disabled['flash'])
			$codetocache[] = isset($disabled['url']) ? '$3' : '<a href="$3" target="_new">$3</a>';
		else
			$codetocache[] = '<object classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000" width="$1" height="$2"><param name="movie" value="$3" /><param name="play" value="true" /><param name="loop" value="true" /><param name="quality" value="high" /><param name="AllowScriptAccess" value="never" /><embed src="$3" width="$1" height="$2" play="true" loop="true" quality="high" AllowScriptAccess="never"></embed></object>';
	}

	// Nothing to parse... ?
	if (!strstr($message, '[') && !strstr($message, '://') && !strstr($message, '@') && !strstr($message, '/me') && !strstr($message, '&lt;'))
		return;

	// Replace <a href="something">somewhere</a> with HTML.
	if (!empty($modSettings['enablePostHTML']) && strstr($message, '&lt;'))
	{
		$message = preg_replace('~&lt;a\s+href=(?:&quot;)?(?:\[url\])?((?:http://|ftp:/\|https://|ftps://|mailto:).+?)(?:\[/url\])?(?:&quot;)?&gt;(.+?)&lt;/a&gt;~ie', '\'<a href="$1">\' . preg_replace(\'~(\[url.*?\]|\[/url\])~\', \'\', \'$2\') . \'</a>\'', $message);

		// Do <img ... /> - with security... action= -> action-.
		preg_match_all('~&lt;img\s+src=(?:&quot;)?(?:\[url\])?((?:http://|ftp://|https://|ftps://).+?)(?:\[/url\])?(?:&quot;)?(?:\s+alt=(?:&quot;)?(.*?)(?:&quot;)?)?(?:\s?/)?&gt;~i', $message, $matches, PREG_PATTERN_ORDER);
		if (!empty($matches[0]))
		{
			$replaces = array();
			foreach ($matches[1] as $match => $imgtag)
			{
				// No alt?
				if (!isset($matches[2][$match]))
					$matches[2][$match] = '';

				// Remove action= from the URL - no funny business, now.
				if ($imgtag != preg_replace('~action(=|%3d)(?!dlattach)~i', 'action-', $imgtag))
					$replaces[$matches[0][$match]] = '<img src="' . preg_replace('~action(=|%3d)(?!dlattach)~i', 'action-', $imgtag) . '" alt="' . $matches[2][$match] . '" border="0" />';

				// Check if the image is larger than allowed.
				if (!empty($modSettings['maxwidth']) && !empty($modSettings['maxheight']))
				{
					list ($width, $height) = url_image_size($imgtag);

					if ($width > $modSettings['maxwidth'] || $height > $modSettings['maxheight'])
					{
						if ($width > $modSettings['maxwidth'] && !empty($modSettings['maxwidth']))
						{
							$height = floor($modSettings['maxwidth'] / $width * $height);
							$width = $modSettings['maxwidth'];
							if ($height > $modSettings['maxheight'] && !empty($modSettings['maxheight']))
							{
								$width = floor($modSettings['maxheight'] / $height * $width);
								$height = $modSettings['maxheight'];
							}
						}
						else
						{
							if ($height > $modSettings['maxheight'] && !empty($modSettings['maxheight']))
							{
								$width = floor($modSettings['maxheight'] / $height * $width);
								$height = $modSettings['maxheight'];
							}
						}
					}

					// Set the new image tag.
					$replaces[$matches[0][$match]] = '<img src="' . preg_replace('~action(=|%3d)(?!dlattach)~i', 'action-', $imgtag) . '" width="' . $width . '" height="' . $height . '" alt="' . $matches[2][$match] . '" border="0" />';
				}
				elseif (strpos($matches[0][$match], '[url]') !== false || substr($matches[0][$match], 0, 4) == '&lt;')
					$replaces[$matches[0][$match]] = '<img src="' . preg_replace('~action(=|%3d)(?!dlattach)~i', 'action-', $imgtag) . '" alt="' . $matches[2][$match] . '" border="0" />';
			}

			$message = strtr($message, $replaces);
		}
	}

	// Do the code if necessary.
	if (strstr($message, '[') || strstr($message, '://') || strstr($message, '@') || strstr($message, '/me'))
	{
		$shadow_directions = array('left' => '270', 'right' => '90', 'top' => '0', 'bottom' => '180');

		$message = preg_replace($codefromcache, $codetocache, $message);

		// Tables need to be done twice or they won't work properly.
		if (strpos($message, '<table>') !== false)
		{
			for ($i = 0; $i < 2; $i++)
				$message = preg_replace(
					array(
						'~((?:<table>|</tr>|\[/tr\])(?:\s|\xA0|<br />|&nbsp;)*(?:<tr>|\[tr\])|</td>|\[/td\])(?:\s|\xA0|<br />|&nbsp;)*\[td\](?:\s|\xA0|<br />|&nbsp;)*(.*?)(?:\s|\xA0|<br />|&nbsp;)*\[/td\](?:\s|\xA0|<br />|&nbsp;)*((?:</tr>|\[/tr\])(?:\s|\xA0|<br />|&nbsp;)*(?:<tr>|\[tr\]|</table>)|<td(?: valign="top")?>|\[td\])~i',
						'~(<table>|</tr>|\[/tr\])(?:\s|\xA0|<br />|&nbsp;)*\[tr\](?:\s|\xA0|<br />|&nbsp;)*(.*?)(?:\s|\xA0|<br />|&nbsp;)*\[/tr\](?:\s|\xA0|<br />|&nbsp;)*(</table>|<tr>|\[tr\])~i'
					),
					array(
						'$1<td valign="top">$2</td>$3',
						'$1<tr>$2</tr>$3'
					), $message
				);
		}
	}

	// Enable Basic HTML?
	if (!empty($modSettings['enablePostHTML']) && strstr($message, '&lt;'))
	{
		// b, u, i, s, pre... basic tags.
		$closable_tags = array('b', 'u', 'i', 's', 'pre', 'blockquote');
		foreach ($closable_tags as $tag)
		{
			$opens = substr_count($message, '&lt;' . $tag . '&gt;');
			$closes = substr_count($message, '&lt;/' . $tag . '&gt;');
			$message = str_replace(array('&lt;' . $tag . '&gt;', '&lt;/' . $tag . '&gt;'), array('<' . $tag . '>', '</' . $tag . '>'), $message);

			if ($closes < $opens)
				$message .= str_repeat('</' . $tag . '>', $opens - $closes);
		}

		// <br /> should be empty.
		$empty_tags = array('br');
		foreach ($empty_tags as $tag)
			$message = str_replace(array('&lt;' . $tag . '&gt;', '&lt;' . $tag . '/&gt;', '&lt;' . $tag . ' /&gt;'), '<' . $tag . ' />', $message);
	}
}
</search for>

<replace>
// Parses the code in message, using the normal syntax used by some many forums...
function parsecode(&$message)
{
	global $modSettings, $scripturl, $txt;

	// Something to parse... ?
	$ubbc = strpos($message, '[') !== false || strpos($message, '://') !== false || strpos($message, '@') !== false || strpos($message, '/me') !== false ? true : false;
	$html = !empty($modSettings['enablePostHTML']) && strpos($message, '&lt;') !== false ? true : false;

	if(!$ubbc && !$html)
		return;

	// UBBC
	if($ubbc){
		// Build the list of disabled tags.
		if(!isset($disabled)){
			static $disabled = array();
			if(!empty($modSettings['disabledBBC'])){
				$arr = explode(',', $modSettings['disabledBBC']);
				if(!empty($arr))
					for($i=count($arr); --$i>=0;)
						$disabled[trim($arr[$i])] = true;
			}
		}

		// What tags are used in this message?
		preg_match_all('~\[\w+\W~i', $message, $match);

		// Add the replacements needed for this message.
		if(!empty($match[0])){
			$add = array_flip($match[0]);
			$arr1 = array();
			$arr2 = array();

			// A named email address. [email=me@some.place.com]me[/email]
			if(isset($add['[email='])){
				$arr1[] = '~\[email=(.+?)\](.+?)\[/email\]~ie';
				$arr2[] = isset($disabled['email']) ? '$2 ($1)' : '\'<a href="mailto:$1">\' . preg_replace(\'~(\[url.*?\]|\[/url\]|\[ftp.*?\]|\[/ftp\])~\', \'\', strtr(\'$2\', array(\'@\' => \'&#64;\'))) . \'</a>\'';
			}
			// Find an inside link. (named?) ie. [iurl]www.simplemachines.org[/iurl]
			if(isset($add['[iurl='])){
				$arr1[] = '~\[iurl=([^\]]+?)\]([^\[\]]+?)\[/iurl\]~i';
				$arr1[] = '~\[iurl=(.+?)\](.+?)\[/iurl\]~ie';
				if(isset($disabled['iurl'])){
					if(isset($disabled['url'])){
						$arr2[] = '$2 ($1)';
						$arr2[] = 'preg_replace(\'~(\[url.*?\]|\[/url\])~\', \'\', \'$2\') . \' ($1)\'';
					}else{
						$arr2[] = '<a href="$1" target="_blank">$2</a>';
						$arr2[] = '\'<a href="$1" target="_blank">\' . preg_replace(\'~(\[url.*?\]|\[/url\])~\', \'\', strtr(\'$2\', array(\'@\' => \'&#64;\'))) . \'</a>\'';
					}
				}else{
					$arr2[] = '<a href="$1">$2</a>';
					$arr2[] = '\'<a href="$1">\' . preg_replace(\'~(\[url.*?\]|\[/url\])~\', \'\', strtr(\'$2\', array(\'@\' => \'&#64;\'))) . \'</a>\'';
				}
			}
			if(isset($add['[iurl]'])){
				$arr1[] = '~\[iurl\](.+?)\[/iurl\]~i';
				$arr2[] = isset($disabled['iurl']) ? (isset($disabled['url']) ? '$1' : '<a href="$1" target="_blank">$1</a>') : '<a href="$1">$1</a>';
			}
			// FTP link.  Named...?  [ftp=upload.sourceforge.net]Sourceforge[/ftp]
			if(isset($add['[ftp]'])){
				$arr1[] = '~\[ftp\](.+?)\[/ftp\]~ie';
				$arr2[] = isset($disabled['ftp']) ? 'preg_replace(\'~(\[url.*?\]|\[/url\])~\', \'\', \'$1\')' : '\'<a href="$1" target="_blank">\' . preg_replace(\'~(\[url.*?\]|\[/url\])~\', \'\', strtr(\'$1\', array(\'@\' => \'&#64;\'))) . \'</a>\'';
			}
			if(isset($add['[ftp='])){
				$arr1[] = '~\[ftp=(.+?)\](.+?)\[/ftp\]~ie';
				$arr2[] = isset($disabled['ftp']) ? 'preg_replace(\'~(\[url.*?\]|\[/url\])~\', \'\', \'$2\') . \' ($1)\'' : '\'<a href="$1" target="_blank">\' . preg_replace(\'~(\[url.*?\]|\[/url\])~\', \'\', strtr(\'$2\', array(\'@\' => \'&#64;\'))) . \'</a>\'';
			}
			// Find a (named?) URL... [url]www.simplemachines.org[/url] or [url=www.simplemachines.org]SMF[/url]
			if(isset($add['[url='])){
				$arr1[] = '~\[url=([^\]]+?)\]([^\]]*?\[url(?:=[^\]]+?)?\].+?\[/url\].*?)\[/url\]~ie';
				$arr1[] = '~\[url=(.+?)\](.+?)\[/url\]~ie';
				if(isset($disabled['url'])){
					$arr2[] = 'preg_replace(\'~(\[url.*?\]|\[/url\])~\', \'\', \'$2\') . \' ($1)\'';
					$arr2[] = '\'$2 ($1)\'';
				}else{
					$arr2[] = '\'<a href="$1" target="_blank">\' . preg_replace(\'~(\[url.*?\]|\[/url\])~\', \'\', strtr(\'$2\', array(\'@\' => \'&#64;\'))) . \'</a>\'';
					$arr2[] = '\'<a href="$1" target="_blank">\' . strtr(\'$2\', array(\'@\' => \'&#64;\')) . \'</a>\'';
				}
			}
			if(isset($add['[url]'])){
				$arr1[] = '~\[url\](?:<br />)*(.+?)(?:<br />)*\[/url\]~i';
				$arr2[] = isset($disabled['url']) ? '$1' : '<a href="$1" target="_blank">$1</a>';
			}
			// Bold, italics, underline, strikeout.
			if(isset($add['[b]'])){
				$arr1[] = '~\[b\](.+?)\[/b\]~i';
				$arr2[] = isset($disabled['b']) ? '$1' : '<b>$1</b>';
			}
			if(isset($add['[i]'])){
				$arr1[] = '~\[i\](.+?)\[/i\]~i';
				$arr2[] = isset($disabled['i']) ? '$1' : '<i>$1</i>';
			}
			if(isset($add['[u]'])){
				$arr1[] = '~\[u\](.+?)\[/u\]~i';
				$arr2[] = isset($disabled['u']) ? '$1' : '<span style="text-decoration: underline;">$1</span>';
			}
			if(isset($add['[s]'])){
				$arr1[] = '~\[s\](.+?)\[/s\]~i';
				$arr2[] = isset($disabled['s']) ? '$1' : '<del>$1</del>';
			}
			// A quote.  May or may not specify an author and/or link and date.
			$add['[/quote'] = false;
			if(isset($add['[quote]'])){
				$add['[/quote'] = true;
				$arr1[] = '~\[quote\](?:<br />)?~i';
				$arr2[] = '<div class="quoteheader">' . $txt['smf240'] . '</div><div class="quote">';
			}
			if(isset($add['[quote ']) || isset($add['[quote='])){
				$add['[/quote'] = true;
				$arr1[] = '~\[quote(?: author)?=&quot;(.{1,80}?)&quot;\](?:<br />)?~i';
				$arr2[] = '<div class="quoteheader">' . $txt['smf239'] . ': $1</div><div class="quote">';
				$arr1[] = '~\[quote author=(.{1,80}?) link=(?:board=\d+;)?((?:topic|threadid)=[\dmsg#\./]{1,40}(?:;start=[\dmsg#\./]{1,40})?) date=(\d+)\](?:<br />)?~ei';
				$arr2[] = '\'<div class="quoteheader"><a href="' . $scripturl . '?$2">' . $txt['smf239'] . ': $1 ' . $txt[176] . ' \' . timeformat(\'$3\') . \'</a></div><div class="quote">\'';
				$arr1[] = '~\[quote author=(.{1,80}?)\](?:<br />)?~i';
				$arr2[] = '<div class="quoteheader">' . $txt['smf239'] . ': $1</div><div class="quote">';
			}
			if($add['[/quote']){
				$arr1[] = '~\[/quote\](?:<br />)?~i';
				$arr2[] = '</div>';
			}
			// An image.  Width and height can be are optional.
			if(isset($add['[img]']) || isset($add['[img '])){
				$arr1[] = '~\[img(\s+width=([\d]+))?(\s+height=([\d]+))?\s*\](?:<br />)*(.+?)(?:<br />)*\[/img\]~ei';
				$arr2[] = isset($disabled['img']) ? '$5' : '\'<img src="$5" alt=""\' . (\'$2\' != \'\' ? \' width="$2"\' : \'\') . (\'$4\' != \'\' ? \' height="$4"\' : \'\') . \' border="0" />\'';
			}
			// Size the font.  [size=large]HELLO![/size]
			if(isset($add['[size='])){
				$arr1[] = '~\[size=([\d]{1,2}p[xt]|(?:x-)?small(?:er)?|(?:x-)?large[r]?)\](.+?)\[/size\]~i';
				$arr1[] = '~\[size=([\d])\](.+?)\[/size\]~i';
				if(isset($disabled['size'])){
					$arr2[] = '$2';
					$arr2[] = '$2';
				}else{
					$arr2[] = '<span style="font-size: $1;">$2</span>';
					$arr2[] = '<font size="$1">$2</font>';
				}
			}
			// Performat/justify text.  [center]Justifying is good.[/center]
			if(isset($add['[pre]'])){
				$arr1[] = '~\[pre\](.+?)\[/pre\]~i';
				$arr2[] = isset($disabled['pre']) ? '$1' : '<pre>$1</pre>';
			}
			if(isset($add['[left]'])){
				$arr1[] = '~\[left\](.+?)\[/left\]~i';
				$arr2[] = isset($disabled['left']) ? '$1' : '<div align="left">$1</div>';
			}
			if(isset($add['[right]'])){
				$arr1[] = '~\[right\](.+?)\[/right\]~i';
				$arr2[] = isset($disabled['right']) ? '$1' : '<div align="right">$1</div>';
			}
			if(isset($add['[center]'])){
				$arr1[] = '~\[center\](.+?)\[/center\]~i';
				$arr2[] = isset($disabled['center']) ? '$1' : '<div align="center">$1</div>';
			}
			// Teletyped text. Monospace, in other words.
			if(isset($add['[tt]'])){
				$arr1[] = '~\[tt\](.+?)\[/tt\]~i';
				$arr2[] = isset($disabled['tt']) ? '$1' : '<tt>$1</tt>';
			}
			// Subscript and superscript.  6[sup]2[/sup] = 36.
			if(isset($add['[sub]'])){
				$arr1[] = '~\[sub\](.+?)\[/sub\]~i';
				$arr2[] = isset($disabled['sub']) ? '$1' : '<sub>$1</sub>';
			}
			if(isset($add['[sup]'])){
				$arr1[] = '~\[sup\](.+?)\[/sup\]~i';
				$arr2[] = isset($disabled['sup']) ? '$1' : '<sup>$1</sup>';
			}
			// An email address. [email]me@some.place.com[/email]
			if(isset($add['[email]'])){
				$arr1[] = '~\[email\](?:<br />)*(.+?)(?:<br />)*\[/email\]~i';
				$arr2[] = isset($disabled['email']) ? '$1' : '<a href="mailto:$1">$1</a>';
			}
			// Specify a specific font.  [font=Comic Sans]Blah![/font]
			if(isset($add['[font='])){
				$arr1[] = '~\[font=([\w,\-\s]+?)\](.+?)\[/font\]~i';
				$arr2[] = isset($disabled['font']) ? '$2' : '<span style="font-family: $1;">$2</span>';
			}
			// Colors.... [red]See?[/red]
			if(isset($add['[color='])){
				$arr1[] = '~\[color=(#[\da-fA-F]{3}|#[\da-fA-F]{6}|[\w]{1,12})\](.*?)\[/color\]~i';
				$arr2[] = isset($disabled['color']) ? '$2' : '<span style="color: $1;">$2</span>';
			}
			if(isset($add['[black]'])){
				$arr1[] = '~\[black\](.+?)\[/black\]~i';
				$arr2[] = isset($disabled['color']) ? '$1' : '<span style="color: black;">$1</span>';
			}
			if(isset($add['[white]'])){
				$arr1[] = '~\[white\](.+?)\[/white\]~i';
				$arr2[] = isset($disabled['color']) ? '$1' : '<span style="color: white;">$1</span>';
			}
			if(isset($add['[red]'])){
				$arr1[] = '~\[red\](.+?)\[/red\]~i';
				$arr2[] = isset($disabled['color']) ? '$1' : '<span style="color: red;">$1</span>';
			}
			if(isset($add['[green]'])){
				$arr1[] = '~\[green\](.+?)\[/green\]~i';
				$arr2[] = isset($disabled['color']) ? '$1' : '<span style="color: green;">$1</span>';
			}
			if(isset($add['[blue]'])){
				$arr1[] = '~\[blue\](.+?)\[/blue\]~i';
				$arr2[] = isset($disabled['color']) ? '$1' : '<span style="color: blue;">$1</span>';
			}
			if(isset($add['[kissy]']) || isset($add['[chrissy]'])){
				$arr1[] = '~\[(chr|k)issy\](.+?)\[/\1issy\]~i';
				$arr2[] = isset($disabled['color']) ? '$2' : '<span style="color: #CC0099;">$2 :-*</span>';
			}
			// Lists... [list][*]First, ...[o]Second![li]THIRD!!![/li][/list]
			if(isset($add['[list]'])){
				$arr1[] = '~\[list\](?:<br />)?~i';
				$arr1[] = '~\[/list\](?:<br />)?~i';
				$arr1[] = '~(?:<br />|&nbsp;|\s)*\[li\](.+?)\[/li\](?:<br />|&nbsp;|\s)*~i';
				if(isset($disabled['list']) || isset($disabled['li'])){
					$arr2[] = '';
					$arr2[] = '';
					$arr2[] = '<br />$1<br />';
				}else{
					$arr2[] = '<ul style="margin-top: 0; margin-bottom: 0;">';
					$arr2[] = '</ul>';
					$arr2[] = '<li>$1</li>';
				}
			}
			// Horizontal rule. [hr] => ------------------
			if(isset($add['[hr]']) || isset($add['[hr '])){
				$arr1[] = '~\[hr(?:\s*/)?\]~i';
				$arr2[] = isset($disabled['hr']) ? '' : '<hr />';
			}
			// A break.  [br] or [br /].
			if(isset($add['[br]']) || isset($add['[br '])){
				$arr1[] = '~\[br(?:\s*/)?\]~i';
				$arr2[] = '<br />';
			}
			// Right-to-left and left-to-right strings.
			if(isset($add['[ltr]'])){
				$arr1[] = '~\[ltr\](.+?)\[/ltr\]~i';
				$arr2[] = isset($disabled['ltr']) ? '$1' : '<div dir="ltr">$1</div>';
			}
			if(isset($add['[rtl]'])){
				$arr1[] = '~\[rtl\](.+?)\[/rtl\]~i';
				$arr2[] = isset($disabled['rtl']) ? '$1' : '<div dir="rtl">$1</div>';
			}
			// Acronyms and abbreviations... [acronym=Bulletin Board Code]BBC[/acronym]
			if(isset($add['[acronym='])){
				$arr1[] = '~\[acronym=((?:&quot;)?)(.+?)\\1\](.+?)\[/\\1\]~i';
				$arr2[] = isset($disabled['acronym']) ? '$3' : '<acronym title="$2">$3</$1>';
			}
			if(isset($add['[abbr='])){
				$arr1[] = '~\[abbr=((?:&quot;)?)(.+?)\\1\](.+?)\[/\\1\]~i';
				$arr2[] = isset($disabled['abbr']) ? '$3' : '<abbr title="$2">$3</$1>';
			}
			// [me=Comment]does something[/me]
			if(isset($add['[me='])){
				$arr1[] = '~\[me=((?:&quot;)?)(.{1,80}?)\\1\](.+?)\[/me\](?:<br />)?~i';
				$arr2[] = isset($disabled['me']) ? '* $2 $3' : '<div class="meaction">* $2 $3</div>';
			}
			// An email address they just typed in. Don't match if there's already a mailto: or = before it.
			if(strpos($message, '@') !== false){
				$arr1[] = '~(?<=[\?\s\xA0[\]()*\\\;>]|^)([\w\-\.]{1,80}@[\w\-]+\.[\w\-\.]+[\w\-])(?=[?,\s\xA0\[\]()*\\\]|$|<br />|&nbsp;|&gt;|&lt;|&quot;|&#039;|\.(?:\.|&nbsp;|\s|$|<br />))~i';
				$arr1[] = '~(?<=<br />)([\w\-\.]{1,80}@[\w\-]+\.[\w\-\.]+[\w\-])(?=[?\.,\s\xA0\[\]()*\\\]|$|<br />|&nbsp;|&gt;|&lt;|&quot;|&#039;)~i';
				if(isset($disabled['email'])){
					$arr2[] = '$1';
					$arr2[] = '$1';
				}else{
					$arr2[] = '<a href="mailto:$1">$1</a>';
					$arr2[] = '<a href="mailto:$1">$1</a>';
				}
			}
			// Match a table... hopefully with everything in the right place.
			if(isset($add['[table]']) && isset($add['[tr]']) && isset($add['[td]'])){
				$arr1[] = '~\[table\](.*?)\[/table\](?:\s|\xA0|<br />|&nbsp;)?~ie';
				$arr2[] = '\'<table>\' . parse_table(\'$1\') . \'</table>\'';
			}
			// GLOWING or /shadowed/ text.
			if(isset($add['[glow='])){
				$arr1[] = '~\[glow=([#\w]{3,12}),([012]\d{0,2})(,[^]]+)?\](.+?)\[/glow\]~i';
				$arr2[] = isset($disabled['glow']) ? '$4' : '<table border="0" cellpadding="0" cellspacing="0" style="display: inline; vertical-align: middle; font: inherit;"><tr><td style="filter: Glow(color=$1, strength=$2); font: inherit;">$4</td></tr></table> ';
			}
			if(isset($add['[shadow='])){
				$arr1[] = '~\[shadow=([#\w]{3,12}),(left|right|top|bottom|[0123]\d{0,2})\](.+?)\[/shadow\]~ei';
				$arr2[] = isset($disabled['shadow']) ? 'strtr(\'$3\', array(\'\\"\' => \'"\'))' : '\'<table border="0" cellpadding="0" cellspacing="0" style="display: inline; vertical-align: middle; font: inherit;"><tr><td style="filter: Shadow(color=$1, direction=\' . (isset($shadow_directions[\'$2\']) ? $shadow_directions[\'$2\'] : (int) \'$2\') . \'); font: inherit;">\' . strtr(\'$3\', array(\'\\"\' => \'"\')) . \'</td></tr></table> \'';
			}
			// Moving text... [move]stuff[/move]
			if(isset($add['[move]'])){
				$arr1[] = '~\[move\](.+?)\[/move\]~i';
				$arr2[] = isset($disabled['move']) ? '$1' : '<marquee>$1</marquee>';
			}
			// Handle flash.
			if(isset($add['[flash='])){
				$arr1[] = '~\[flash=(\d+),(\d+)\](?:<br />)*(.+?)(?:<br />)*\[/flash\]~i';
				if(empty($modSettings['enableEmbeddedFlash']) || isset($disabled['flash']))
					$arr2[] = isset($disabled['url']) ? '$3' : '<a href="$3" target="_new">$3</a>';
				else
					$arr2[] = '<object classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000" width="$1" height="$2"><param name="movie" value="$3" /><param name="play" value="true" /><param name="loop" value="true" /><param name="quality" value="high" /><param name="AllowScriptAccess" value="never" /><embed src="$3" width="$1" height="$2" play="true" loop="true" quality="high" AllowScriptAccess="never"></embed></object>';
			}
		}
	}

	// HTML.
	if($html){
		// Replace <a href="something">somewhere</a> with HTML.
		$message = preg_replace('~&lt;a\s+href=(?:&quot;)?(?:\[url\])?((?:http://|ftp:/\|https://|ftps://|mailto:).+?)(?:\[/url\])?(?:&quot;)?&gt;(.+?)&lt;/a&gt;~ie', '\'<a href="$1">\' . preg_replace(\'~(\[url.*?\]|\[/url\])~\', \'\', \'$2\') . \'</a>\'', $message);

		// Do <img ... /> - with security... action= -> action-.
		preg_match_all('~&lt;img\s+src=(?:&quot;)?(?:\[url\])?((?:http://|ftp://|https://|ftps://).+?)(?:\[/url\])?(?:&quot;)?(?:\s+alt=(?:&quot;)?(.*?)(?:&quot;)?)?(?:\s?/)?&gt;~i', $message, $matches, PREG_PATTERN_ORDER);
		if(!empty($matches[0])){
			$replaces = array();
			foreach ($matches[1] as $match => $imgtag){
				// Remove action= from the URL - no funny business, now.
				if($imgtag != preg_replace('~action(=|%3d)(?!dlattach)~i', 'action-', $imgtag))
					$replaces[$matches[0][$match]] = '<img src="' . preg_replace('~action(=|%3d)(?!dlattach)~i', 'action-', $imgtag) . '" alt="' . $matches[2][$match] . '" border="0" />';

				// Check if the image is larger than allowed.
				if(!empty($modSettings['maxwidth']) && !empty($modSettings['maxheight'])){
					list ($width, $height) = url_image_size($imgtag);

					if($width > $modSettings['maxwidth'] || $height > $modSettings['maxheight']){
						if($width > $modSettings['maxwidth'] && !empty($modSettings['maxwidth'])){
							$height = floor($modSettings['maxwidth'] / $width * $height);
							$width = $modSettings['maxwidth'];
							if($height > $modSettings['maxheight'] && !empty($modSettings['maxheight'])){
								$width = floor($modSettings['maxheight'] / $height * $width);
								$height = $modSettings['maxheight'];
							}
						}else{
							if($height > $modSettings['maxheight'] && !empty($modSettings['maxheight'])){
								$width = floor($modSettings['maxheight'] / $height * $width);
								$height = $modSettings['maxheight'];
							}
						}
					}

					// Set the new image tag.
					$replaces[$matches[0][$match]] = '<img src="' . preg_replace('~action(=|%3d)(?!dlattach)~i', 'action-', $imgtag) . '" width="' . $width . '" height="' . $height . '" alt="" border="0" />';
				}
				elseif (strpos($matches[0][$match], '[url]') !== false || substr($matches[0][$match], 0, 4) == '&lt;')
					$replaces[$matches[0][$match]] = '<img src="' . preg_replace('~action(=|%3d)(?!dlattach)~i', 'action-', $imgtag) . '" alt="' . $matches[2][$match] . '" border="0" />';
			}

			$message = strtr($message, $replaces);
		}
	}

	// Do the code if necessary.
	if(!empty($arr1)){
		$shadow_directions = array('left' => '270', 'right' => '90', 'top' => '0', 'bottom' => '180');

		$message = preg_replace($arr1, $arr2, $message);

		// This last one fixes spaces at the beginning of lines.
		$message = strtr($message, array('<br /> ' => '<br />&nbsp;'));
	}

	// HTML.
	if($html){
		// b, u, i, s, pre... basic tags.
		$closable_tags = array('b', 'u', 'i', 's', 'pre', 'blockquote');
		foreach ($closable_tags as $tag){
			$opens = substr_count($message, '&lt;' . $tag . '&gt;');
			$closes = substr_count($message, '&lt;/' . $tag . '&gt;');
			$message = str_replace(array('&lt;' . $tag . '&gt;', '&lt;/' . $tag . '&gt;'), array('<' . $tag . '>', '</' . $tag . '>'), $message);

			if($closes < $opens)
				$message .= str_repeat('</' . $tag . '>', $opens - $closes);
		}

		// <br /> should be empty.
		$empty_tags = array('br');
		foreach ($empty_tags as $tag)
			$message = str_replace(array('&lt;' . $tag . '&gt;', '&lt;' . $tag . '/&gt;', '&lt;' . $tag . ' /&gt;'), '<' . $tag . ' />', $message);
	}
}
function parse_table($table){
	$table = strtr($table, array('&nbsp; ' => '  ', '<br />' => "\n"));
	$table = preg_replace(array('~\s*\[td\](.*?)\[/td\]\s*~is', '~\s*\[tr\](.*?)\[/tr\]\s*~is'), array('<td valign="top">$1</td>', '<tr>$1</tr>'), $table);
	$table = strtr($table, array('  ' => '&nbsp; ', "\n" => '<br />'));
	return $table;
}
</replace>
